* _________________________________________________________________ / / /_
*                                                                  / / /
* Flashtro.com                                              ____  / / /
* cracktro source                                           \   \/ / /
* ________________________________________ powered by AMIGA _\ \ \/ /_____
*                                                             \_\_\/
* CRYSTAL 17 intro "Tweety"
* original code by Ted's Farm/Movement
* original custom module Delta V2.0 "The Last V8" by Stello Doussis
* (original C64 version by Rob Hubbard)
* resourced by VrS!
* hit RETURN to quit
* 
* upd. 01/08/06

;ASMONE
	ifnd	ASMONE
	opt	c-
	endc

	ifd	ASMONE
	incdir	"dh0:crystal17"
	endc

* ----------------------------------- TabShift execlib
OpenLib	equ	-552
CloseLib	equ	-414	
Forbid	equ	-132
Permit	equ	-138
Supervisor	equ	-30

* ----------------------------------- TabShift gfxlib
LoadView	equ	-222
WaitBlit	equ	-228
WaitTOF	equ	-270
OwnBlit	equ	-456
DisownBlit	equ	-462

* ----------------------------------- TabShift customs
BLTCON0=$40		
BLTCON1=$42
BLTAFWM=$44
BLTALWM=$46
BLTCPTH=$48
BLTCPTL=$4A
BLTBPTH=$4C
BLTBPTL=$4E
BLTAPTH=$50
BLTAPTL=$52
BLTDPTH=$54
BLTDPTL=$56
BLTSIZE=$58
BLTCMOD=$60
BLTBMOD=$62
BLTAMOD=$64
BLTDMOD=$66
BLTCDAT=$70
BLTBDAT=$72
BLTADAT=$74
DMACONR=$2

* ------------------------------------ TabShift dmacon
D_init=$8200
D_priB=$400
D_Btpl=$100
D_Copp=$80
D_Blit=$40
D_sprt=$20
D_disk=$10
D_CON=D_init|D_copp|D_Btpl|D_Blit|D_priB

* ------------------------------------- parametres modifiables
DM	; deltamusic

W=44
H=130
H2=70
WB=46
HB=25
* -------------------------------------
	section	tedsfarm,code
	
Start:	movem.l	d0-d7/a0-a6,-(sp)
	
	movea.l	4.w,a6
	lea	GfxName(pc),a1
	moveq	#0,d0
	jsr	OpenLib(a6)
	tst.l	d0
	beq	NoGfx
	
	lea	GfxBase(pc),a0
	move.l	d0,(a0)
	move.l	d0,a6
	
	lea	OldView(pc),a0
	move.l	$22(a6),(a0)
	
	suba.l	a1,a1
	jsr	LoadView(a6)
	
	jsr	WaitTOF(a6)
	jsr	WaitTOF(a6)
	jsr	WaitBlit(a6)
	
	movea.l	4.w,a6
	jsr	Forbid(a6)
	
	bsr	GetVBR
; my init
* --
	ifd	DM
	bset	#1,$bfe001
	moveq	#1,d0			; INIT MUSIC
	jsr	music_data		; CALL THE PLAYER
	endc

	bsr	Init
	bsr	Initialization

* Main Program ------------------------------------------------------
	bsr	Bounce

	move.l	#NewCopper,$dff080
	move.w	#0,$dff088

	lea	flagVBL(pc),a1
	move.w	#-1,(a1)
.tstvbl:
	move.w	(a1),d0
	bmi.s	.tstvbl
	move.w	#-1,(a1)

	move.w	#$8180,$dff096
* --- keyboard test
waitKey:
	move.b	$bfed01,d0
	btst	#3,d0
	beq.s	main
	movem.l	d0-d2,-(sp)
	moveq	#0,d0
	move.b	$bfec01,d0
	bset	#6,$bfee01
	move.b	#-1,$bfec01
;	moveq	#1,d2
;loopvbl:
;	move.b	$dff006,d1
;.waitvbl:
;	cmp.b	$dff006,d1
;	beq.s	.waitvbl
;	dbf	d2,loopvbl
	bsr	waitraster

	bclr	#6,$bfee01
	cmpi.b	#$77,d0         ; return
	movem.l	(sp)+,d0-d2
	bne.s	main
* -- end
	lea	flag2fad(pc),a0
	move.w	(a0),d0
	bne.s	main
	move.w	#64,(a0)
* ---
main:	lea	flagVBL(pc),a0
.tstvb:	move.w  (a0),d0
	bmi.s	.tstvb
	bsr	Fading
	bsr	Wave
	bsr	WriteText
	bsr	Tweety
	lea	flagVBL(pc),a0
	move.w	#-1,(a0)
	bra.s	waitKey

;mouse:	btst	#6,$bfe001
;	bne.s	mouse

* restore -----------------------------------------------------------	
End	bsr	Bounce 
	lea	$dff000,a6

	ifd	DM
	 move.w	#$f,$dff096
	 move.w	#0,$DFF0A8
	 move.w	#0,$DFF0B8
	 move.w	#0,$DFF0C8
	 move.w	#0,$DFF0D8
	endc

	bsr	Restore
	
	movea.l	4.w,a6
	jsr	Permit(a6)
	
	movea.l	GfxBase(pc),a6
	movea.l	OldView(pc),a1
	jsr	LoadView(a6)
	move.l	$26(a6),$dff080
	
	movea.l	a6,a1
	movea.l	4.w,a6
	jsr	CloseLib(a6)
	
NoGfx	movem.l	(sp)+,d0-d7/a0-a6
	moveq	#0,d0
	rts
* ---------------------------------------------	
Init:	lea	$dff000,a6
	lea	Dma(pc),a0
	move.w	2(a6),d0		save dma
	or.w	d0,(a0)+
	move.w	$1c(a6),d0		intena
	or.w	d0,(a0)+
	
	move.w	#$7fff,d0
	move.w	d0,$96(a6)
	move.w	d0,$9a(a6)
	move.w	d0,$9c(a6)
* --	
	movea.l	VBR(pc),a1
	move.l	$6c(a1),(a0)		int3
	
	lea	interrupt(pc),a0
	move.l	a0,$6c(a1)
	move.w	#$c020,$9a(a6)

	lea	CopperList,a0
	move.l	a0,$80(a6)
	move.w	#0,$88(a6)

	move.w	#D_con,$96(a6)
	
	rts
* ---------------------------------------------
Restore:	
	lea	$dff000,a6
	move.w	#$7fff,d0
	move.w	d0,$96(a6)
	move.w	d0,$9a(a6)
	move.w	d0,$9c(a6)
	
	lea	Dma(pc),a0
	movea.l	VBR(pc),a1
	move.l	4(a0),$6c(a1)
	move.w	2(a0),$9a(a6)
	move.w	(a0),$96(a6)
	
	rts
* --------------------------------------------
GetVBR:	movea.l	4.w,a6
	btst	#0,$129(a6)
	beq.s	.normal
	
	lea	SuperCode(pc),a5
	jsr	Supervisor(a6)
	
	lea	VBR(pc),a0
	move.l	d0,(a0)
.normal	rts
	CNOP	0,4
SuperCode:	dc.l	$4e7a0801	; movec Vbr,d0 (680x0)
	rte
* --------------------------------------------
Dma	dc.w	$8000
intena	dc.w	$c000
int3	dc.l	0
GfxBase	dc.l	0
OldView	dc.l	0
VBR	dc.l	0
GfxName	dc.b	'graphics.library',0
	even
* --------------------------------------------
interrupt:	
	movem.l	a0-a6/d0-d7,-(sp)

	lea	$dff000,a6	
	andi.w	#$20,$1e(a6)	interruption VBL
	beq.s	pasInt

	lea	flagVBL(pc),a0
	move.w	#0,(a0)

	ifd	DM
	moveq	#0,d0			; SET REPLAY MODE
	jsr	music_data		; CALL THE PLAYER
	endc

	move.w	#$0020,$dff09c	; ok ! interrupt finished	
pasInt	movem.l	(sp)+,a0-a6/d0-d7	
	rte	
* --------------------------------------------
Place_plans:		
	move.w	d0,6(a0)
	swap	d0			
	move.w 	d0,2(a0)
	swap	d0
	tst.w	d1
	beq.s	.fin
	add.l	d2,d0
	addq.l	#8,a0
	subq.w	#1,d1
	bra.s	place_plans
.fin	rts
* -------------------------------------------
waitblitter	
	btst	#6,$dff002
.wait	btst	#6,$dff002
	bne.s	.wait
	rts
* --------------------------------------------
waitraster
	movem.l	d0,-(sp)
.loop	move.l	$dff004,d0
	and.l	#$1ff00,d0
	cmp.l	#302<<8,d0
	bne.b	.loop
	movem.l	(sp)+,d0
	rts
* --------------------------------------------------------
* - INIT
* --------------------------------------------------------
Initialization:
* -- reset pointers
	lea	bufTabSin,a0
	lea	ptTabSin(pc),a1
	move.l	a0,(a1)

	lea	sBounce,a0
	lea	ptsBounce(pc),a1
	move.l	a0,(a1)

	lea	screen1,a0
	lea	ptScreen1(pc),a1
	move.l	a0,(a1)
	lea	ptScreen2(pc),a1
	move.l	a0,(a1)

	lea	screen2,a0
	lea	ptscreen1_2(pc),a1
	move.l	a0,(a1)
	lea	ptscreen2_2(pc),a1
	move.l	a0,(a1)

	lea	Plan5,a0
	lea	ptPlan5(pc),a1
	move.l	a0,(a1)

	lea	bufFont,a0
	lea	ptBufFont(pc),a1
	move.l	a0,(a1)

	lea	BufFont2,a0
	lea	ptBufFont2(pc),a1
	move.l	a0,(a1)

	lea	PosScreen,a0
	lea	ptPosScreen(pc),a1
	move.l	a0,(a1)
* --
	lea	flagtweety(pc),a1
	move.w	#1,(a1)
* --
* - pic+txt
	move.l	ptScreen1(pc),d0
	lea	CLplan,a0
	move.w	#4-1,d1
	move.l	#W*H,d2
	bsr	place_plans
* - wave
	move.l	ptPlan5(pc),d0
	lea	CLplan5,a0
	moveq	#0,d1
	moveq	#0,d2
	bsr	place_plans
* - 
	move.l	ptsBounce(pc),d0
	lea	CLplan1,a0
	move.w	#4-1,d1
	move.l	#WB*HB,d2
	bsr	place_plans
* ---
	bsr	initFont
	bsr	initTweety
	bsr	initFadeIn
	bsr	initBounceRabbit
	bsr	initWave
	rts
* --------------------------------------------------------
* - Fading
* --------------------------------------------------------
initFadeIn:
	lea	flag2fad(pc),a0
	move.w	#64,(a0)
	lea	Palette(pc),a0
	lea	finalcol(pc),a1
	move.w	#32-1,d7
.loopcol:
	move.w	(a0)+,d0
	move.w	d0,d1
	andi.w	#$F00,d1	; R
	lsl.w	#4,d1
	divs.w	#64,d1
	move.w	d1,(a1)+
	move.w	d0,d1
	andi.w	#$F0,d1		; G
	lsl.w	#8,d1
	divs.w	#64,d1
	move.w	d1,(a1)+
	move.w	d0,d1
	andi.w	#$F,d1		; B
	lsl.w	#6,d1
	lsl.w	#6,d1
	divs.w	#64,d1
	move.w	d1,(a1)+
	dbf     d7,.loopcol
	rts
* -----------------------------------------
Fading:	lea	flag2fad,a5
	move.w	(a5),d0
	beq.s	.exit
	subi.w	#1,(a5)

	lea	CLcol1+2,a0
	lea	finalcol(pc),a1
	lea	black(pc),a2
	move.w	#32-1,d7
.loopcol:
	moveq	#0,d2
	move.w	(a2),d1
	add.w	(a1)+,d1
	move.w	d1,(a2)+
	lsr.w	#4,d1
	andi.w	#$F00,d1	; R
	add.w	d1,d2
	move.w	(a2),d1
	add.w	(a1)+,d1
	move.w	d1,(a2)+
	lsr.w	#8,d1
	andi.w	#$F0,d1		; G
	add.w	d1,d2
	move.w	(a2),d1
	add.w	(a1)+,d1
	move.w	d1,(a2)+
	lsr.w	#8,d1
	lsr.w	#4,d1
	andi.w	#$F,d1		; B
	add.w	d1,d2
	move.w	d2,(a0)
	addq.w	#4,a0
	dbf	d7,.loopcol
	cmpi.w	#0,(a5)
	beq.s	TestEnd
.exit:	rts
* ---
TestEnd:
	move.w	finalcol+2(pc),d0
	bpl.s	invert
	lea	flagVBL(pc),a1
.waitvbl:
	move.w	(a1),d0
	bmi.s	.waitvbl
	move.w	#-1,(a1)
	move.w	#$80,$dff096	; stop copper
	addq.w	#4,sp
	pea	End
	rts     
* ---
invert:	lea	finalcol(pc),a0
	move.w	#96-1,d7
.loop:	neg.w	(a0)+
	dbf	d7,.loop
	rts
* ----------------------------------------------
* - Bouncing Rabbit (blitter/copper)
* ----------------------------------------------
initBounceRabbit:
	lea     ptBounce(pc),a0
	move.l  #WB*HB*4,(a0)
* -- copy rabbit
	lea     Rabbit2(pc),a0		; 16x25x4
	movea.l ptsBounce(pc),a1
	move.w  #HB*4-1,d7
.loop1:	move.w  (a0)+,(a1)
	adda.l  #WB,a1		; next line
	dbf     d7,.loop1

	lea     Rabbit1(pc),a0
	move.w  #HB*4-1,d7
.loop2:	move.w  (a0)+,(a1)
	adda.l  #WB,a1
	dbf     d7,.loop2
* ---
initSin:
	movea.l	ptTabSin(pc),a0
	lea	TabSin(pc),a1	; 390.L
	move.w	#30-1,d7	; 30.L
.loop1:	move.l	(a1)+,(a0)+
	dbf	d7,.loop1

	movea.l	ptTabSin(pc),a1
	move.w	#360-1,d7	; 360.L
.loop2:	move.l	(a1)+,(a0)+
	dbf	d7,.loop2
	rts
* -----------------------------
Bounce:	lea	$dff000,a6
	clr.w	$100(a6)
	lea	flagVBL,a1
	move.w	#-1,(a1)
.wait:	move.w	(a1),d0
	bmi.s	.wait
	move.w	#-1,(a1)

	lea	CopperList,a0
	move.l	a0,$80(a6)
	move.w	#0,$88(a6)
	move.w	#$83c0,$96(a6)
	bra.s	go
* --
waitvbl	lea	flagVBL(pc),a1
.waitvbl:
	tst.w	(a1)
	bmi.s	.waitvbl
	move.w	#-1,(a1)

go:	bsr	waitblitter
* - scroll left->right (blitter)
	move.l	#$29F00000,d6
	lea	bltconBounce(pc),a1
	add.l	(a1)+,d6
	movea.l	ptsBounce(pc),a0
	move.l	a0,bltApth(a6)
	suba.l	(a1),a0
	move.l	a0,bltDpth(a6)
	move.l	d6,bltcon0(a6)
	move.l	#-1,bltAfwm(a6)
	move.l	#0,bltAmod(a6)
	move.w	#(2*25*4)*64+46/2,bltsize(a6)

	bsr	waitblitter

	movea.l	ptTabSin(pc),a0
	lea	cptBounce(pc),a1
	move.w	(a1),d0
	addq.w	#2,(a1)
	cmpi.w	#360,(a1)	; stop ?
	beq.s	stopdisplay

	move.w	(a0,d0.w),d0
	bpl.s	.nodown
	addq.w	#2,(a1)
	move.w	(a1),d0
	move.w	(a0,d0.w),d0
* -- change rabbit
	lea	ptBounce(pc),a0		; swap (2 rabbits: up & down)
	move.l	(a0),d1
	move.l	4(a0),(a0)+
	move.l	d1,(a0)

	move.l	ptsBounce(pc),d2
	add.l	d1,d2
	lea	CLplan1,a0
	move.w	#4-1,d7
.instbpl:
	move.w	d2,6(a0)
	swap	d2
	move.w	d2,2(a0)
	addq.w	#8,a0
	swap	d2
	addi.l	#WB*HB,d2
	dbf	d7,.instbpl
* -- vertical move (copper)
.nodown:
	lsl.w	#8,d0		; sinus move
	move.w	#$de11,d1	; -$21ef / $de11
	sub.w	d0,d1
	lea	linestr,a0
	move.w	d1,(a0)
	addi.w	#$1900,d1	; +25 lines
	lea	linestp,a0
	move.w	d1,(a0)
	bra	waitvbl
* --
stopdisplay:
	clr.w	$100(a6)
	move.w	#$80,$96(a6)
	move.w	#0,(a1)
	movea.l	ptsBounce(pc),a0
	move.w	#(46*25*4*2)/4-1,d7
.clr:	clr.l	(a0)+
	dbf	d7,.clr
* -- change rabbit right to left
	lea	Rabbit3(pc),a0
	movea.l	ptsBounce(pc),a1
	adda.l	#WB-4,a1
	move.w	#2*HB*4-1,d7
.loop:	move.w	(a0)+,(a1)
	adda.l	#WB,a1
	dbf	d7,.loop

	lea	bltconBounce(pc),a0
	move.l	#$C0000000,(a0)+	; to the left
	move.l	#2,(a0)+
	rts
* ------------------------------------------------
* - Tweety  - swap 2 screens
* ------------------------------------------------
initTweety:			; "zoom" raw pic to screen
	lea	picTweety(pc),a0	; 16x15 (2x15)
	movea.l	ptScreen2(pc),a1	; -> screen1
	lea	W*5+3(a1),a1
	moveq	#8-1,d4		; 4 plans x2
.loop1:	
	moveq	#15-1,d7	; 15 lines
.loopline:	
	moveq	#8-1,d6		; 8 words
	move.b	(a0)+,d0        ; .b byte 1
	swap	d0
	move.b	(a0)+,d0        ; .b byte 2 1111111122222222
.loopwrd:	
	moveq	#2-1,d2		; 2 bytes in 1 word
.loopd0:	
	swap	d0		; swap word -> next byte
	moveq	#8-1,d1		; 8 bits
.loopbit:	
	btst	d1,d0		; test bit 0-7
	bne.s	.set
	move.b	#0,(a1)+	; bit not set
	bra.s	.next
.set:	move.b	#-1,(a1)+	; bit set
.next:
	dbf	d1,.loopbit
	dbf	d2,.loopd0
	adda.l	#28,a1		; next line
	dbf	d6,.loopwrd
	dbf	d7,.loopline
	adda.l	#44*10,a1
	dbf	d4,.loop1

* --- shadow - blit 130 lines
	lea	$dff000,a6
	bsr	waitblitter
	move.l	#-1,bltAfwm(a6)
	move.w	#W-20,$60(a6)
	move.w	#W-20,$62(a6)
	move.w	#W-20,$64(a6)
	move.w	#W-20,$66(a6)
	move.w	#2-1,d7		; 2 screens
.loop:	movea.l	ptScreen1(pc),a1
	lea	24(a1),a2
	move.l	#$FFE0000,bltcon0(a6)
	move.l	a1,bltApth(a6)
	adda.l	#H*W*2,a1
	move.l	a1,$4C(a6)
	move.l	a2,$48(a6)
	move.l	a2,bltDpth(a6)
	move.w	#H*64+20/2,bltsize(a6)
	bsr	waitblitter

	move.l	a2,$48(a6)
	move.l	a2,bltDpth(a6)
	move.w	#130*64+20/2,bltsize(a6)
	bsr	waitblitter

	movea.l	ptScreen1(pc),a1
	lea	130+2(a1),a1
	move.l	#$3FDC0000,bltcon0(a6)
	move.l	a2,bltApth(a6)
	adda.l	#H+2,a2
	move.l	a2,bltCpth(a6)
	move.l	a1,bltBpth(a6)
	move.l	a1,bltDpth(a6)
	move.w	#H*64+20/2,bltsize(a6)
	bsr	waitblitter

	movea.l	ptScreen1(pc),a1
	lea	24(a1),a2
	move.l	a2,bltApth(a6)
	adda.l	#H+2,a2
	move.l	a2,bltCpth(a6)
	move.w	#H*64+20/2,bltsize(a6)
	bsr	waitblitter
* swap
	lea	ptScreen1(pc),a0
	move.l	(a0),d0
	move.l	4(a0),(a0)
	move.l	d0,4(a0)
	dbf	d7,.loop
	rts
* -----------------------
Tweety:	lea	flagtweety(pc),a0
	subq.w	#1,(a0)
	bne.s	.exit
	move.w	#25,(a0)	;  wait

	lea	ptScreen1(pc),a0	; swap screen1/screen2
	move.l	(a0),d0
	move.l	4(a0),(a0)
	move.l	d0,4(a0)

	lea	CLplan,a0
	moveq	#4-1,d7
.instbpl:
	move.w	d0,6(a0)
	swap	d0
	move.w	d0,2(a0)
	addq.w	#8,a0
	swap	d0
	addi.l	#W*H,d0
	dbf	d7,.instbpl

.exit:	rts
* ------------------------------------------------
* - Wave
* ------------------------------------------------
initWave:
	lea	MoveWave(pc),a0
	movea.l	ptPosScreen(pc),a1
	move.w	#255-1,d7
.loop:	moveq	#0,d0
	move.b	(a0)+,d0
	mulu	#W,d0
	move.w	d0,(a1)+
	dbf	d7,.loop

	addq.w  #1,a0
	move.w  #509-1,d7
	movea.l ptPosScreen(pc),a0
.loop2:	move.w  (a0)+,(a1)+
	dbf     d7,.loop2
	rts
* ---------------
Wave:	lea	$dff000,a6
* -- clear screen
	movea.l	ptPlan5(pc),a0
	bsr	waitblitter
	move.l	a0,bltDpth(a6)
	move.w	#0,bltDmod(a6)
	move.l	#$1000000,bltcon0(a6)
	move.w	#65*64+W/2,bltsize(a6)

	bsr	waitblitter
* -- plot wave
	lea	cptwave(pc),a1
	movea.l	ptPosScreen(pc),a2
	movea.l	ptPosScreen(pc),a3
	adda.w	(a1),a2
	addi.w	#2,(a1)
	andi.w	#511,(a1)
	move.w	#W*8,d7		; pixel width
.loop:	move.w	(a2)+,d3
	add.w	(a3)+,d3
	move.w	d7,d0
	move.w	d0,d2
	lsr.w	#3,d0
	add.w	d0,d3
	eori.w	#7,d2
	bset	d2,(a0,d3.w)
	dbf	d7,.loop
* -- Fill
	bsr	waitblitter
	move.l	#$DFC0000,bltcon0(a6)
	move.l	a0,bltApth(a6)
	adda.l	#W,a0
	move.l	a0,bltBpth(a6)
	move.l	a0,bltDpth(a6)
	move.w	#0,bltBmod(a6)
	move.l	#0,bltAmod(a6)
	move.w	#65*64+W/2,bltsize(a6)

	bsr	waitblitter
	rts
* ------------------------------------------------
* - Text Writer 8x8 + shaodow blitter (hard!)
* ------------------------------------------------
initFont:
	lea	$dff000,a6
	movea.l	ptBufFont(pc),a0
	adda.l	#96*2,a0
	lea	Font,a1
	moveq	#96-1,d7
.loop:
	move.b	(a1)+,(a0)      ; 8 lines
	move.b	(a1)+,96*2(a0)
	move.b	(a1)+,96*4(a0)
	move.b	(a1)+,96*6(a0)
	move.b	(a1)+,96*8(a0)
	move.b	(a1)+,96*10(a0)
	move.b	(a1)+,96*12(a0)
	move.b	(a1)+,96*14(a0)
	addq.l	#2,a0
	dbf	d7,.loop
* --
	bsr	waitblitter
	movea.l	ptBufFont(pc),a0
	lea	96*24(a0),a1
	adda.w	#96*2,a0
	move.l	#-1,bltAfwm(a6)
	move.l	#0,bltCmod(a6)	; bltCmod+bltBmod
	move.l	#0,bltAmod(a6)
	moveq	#2-1,d7
.loop1	bsr	waitblitter
	move.l	#$1DFC0000,bltcon0(a6)
	move.l	a1,bltBpth(a6)
	move.l	a0,bltApth(a6)
	move.l	a1,bltDpth(a6)
	move.w	#13*64,bltsize(a6)
	adda.w	#96*4,a1
	dbf	d7,.loop1

	suba.w	#96*6,a1
	move.l	#$DFC0000,d0
	moveq	#2-1,d7
.loop2	bsr	waitblitter
	move.l	d0,bltcon0(a6)
	move.l	a1,bltBpth(a6)
	move.l	a0,bltApth(a6)
	move.l	a1,bltDpth(a6)
	move.w	#15*64,bltsize(a6)
	addi.l	#$20000000,d0
	dbf	d7,.loop2

	bsr	waitblitter
	move.l	#$1D0C0000,bltcon0(a6)
	move.l	a1,bltBpth(a6)
	move.l	a0,bltApth(a6)
	move.l	a1,bltDpth(a6)
	move.w	#15*64,bltsize(a6)

	bsr	waitblitter
	move.l	#$19F00000,bltcon0(a6)
	move.l	a0,bltApth(a6)
	move.l	a0,bltDpth(a6)
	move.w	#15*64,bltsize(a6)

	movea.l	ptBufFont(pc),a0
	lea	24*96(a0),a1
	lea	24*96(a1),a2
	lea	24*96(a2),a3

	bsr	waitblitter
	move.l	#$DFC0000,bltcon0(a6)
	move.l	a0,bltBpth(a6)
	move.l	a1,bltApth(a6)
	move.l	a2,bltDpth(a6)
	move.w	#15*64,bltsize(a6)

	bsr	waitblitter
	move.l	#$29F00000,bltcon0(a6)
	move.l	a2,bltApth(a6)
	adda.w	#96*4,a3
	move.l	a3,bltDpth(a6)
	move.w	#15*64,bltsize(a6)

	suba.w	#96*4,a3

	bsr	waitblitter
	move.l	#$D0C0000,bltcon0(a6)
	move.l	a2,bltApth(a6)
	move.l	a3,bltBpth(a6)
	move.l	a3,bltDpth(a6)
	move.w	#15*64,bltsize(a6)

	bsr	waitblitter
	move.l	#$DFC0000,bltcon0(a6)
	move.l	a3,bltApth(a6)
	move.l	a0,bltBpth(a6)
	move.l	a0,bltDpth(a6)
	move.w	#18*64,bltsize(a6)	; 96*12

	bsr	waitblitter
	move.l	#$DFC0000,bltcon0(a6)
	move.l	a3,bltApth(a6)
	move.l	a1,bltBpth(a6)
	move.l	a1,bltDpth(a6)
	move.w	#18*64,bltsize(a6)

	bsr	waitblitter
* -- 
	movea.l	ptBufFont(pc),a0
	movea.l	ptBufFont2(pc),a1
	move.w	#2302,d7
.loop3:	move.w	(a0)+,(a1)+
	move.w	#0,(a1)+
	dbf	d7,.loop3

	movea.l	ptBufFont2(pc),a0
	lea	4608(a0),a1
	lea	4608(a1),a2
	lea	4608(a2),a3
	move.w	#4608/4-1,d7
.loop4:	move.l	(a0)+,d0
	or.l	(a1)+,d0
	move.l	d0,(a2)+
	move.l	d0,(a3)+
	dbf	d7,.loop4
	rts
* -----------------
WriteText:
	move.w	flagtweety(pc),d0
	cmpi.w	#1,d0
	beq.s	.ok
	rts
.ok:	lea	cptchar(pc),a0
	move.w	(a0),d0
	beq.s	newchar
	subq.w	#1,(a0)
	rts
newchar:
	lea	Text(pc),a0
	lea	pText(pc),a4
	adda.w	(a4),a0
	movea.l	ptScreen1(pc),a1
	adda.w	#20,a1
	movea.l	ptBufFont2(pc),a2
	lea	bltcontxt(pc),a5
	move.l	#9216,d6
* - clear
	bsr	waitblitter
	move.l	a1,bltDpth(a6)
	move.w	#W-24,bltDmod(a6)
	move.l	#$1000000,bltcon0(a6)
	move.w	#H*2*64+24/2,bltsize(a6)
* -
	bsr	waitblitter
	move.l	#-1,bltAfwm(a6)
	move.w	#W-4,bltCmod(a6)
	move.w	#384-4,bltBmod(a6)
	move.w	#384-4,bltAmod(a6)
	move.w	#W-4,bltDmod(a6)
	move.l	a0,d0
	moveq	#1,d7
.wait	subq.w	#1,d7
	cmpi.b	#10,(a0)+	; \n
	bne.s	.wait
	addi.w	#22,d7
	lsr.w	#1,d7
	movea.l	d0,a0
.loop:
	moveq	#0,d1
	addq.w	#1,(a4)		; next char ptext+1
	move.b	(a0)+,d1
	subi.w	#10,d1		; "\n" skip line
	beq.s	.skip
	subi.w	#22,d1
	lsl.w	#2,d1
	moveq	#0,d0
	move.w	d7,d0
	andi.w	#1,d0
	lsl.w	#2,d0
	add.l	a2,d1
	move.l	d1,d5
	add.l	d6,d1
	moveq	#0,d3
	move.w	d7,d3
	add.l	a1,d3
	andi.w	#-2,d3
* -
	bsr	waitblitter
	move.l	(a5,d0.w),bltcon0(a6)
	move.l	d5,bltApth(a6)
	move.l	d1,bltBpth(a6)
	move.l	d3,bltCpth(a6)
	move.l	d3,bltDpth(a6)
	move.w	#12*64+4/2,bltsize(a6)

	bsr	waitblitter
	addi.l	#W*H,d3
	move.l	d3,bltDpth(a6)
	move.l	d3,bltCpth(a6)
	move.w	#12*64+4/2,bltsize(a6)
	addq.w	#1,d7
	bra.s	.loop
.skip:
	tst.b	(a0)
	beq.s	.notend
	move.l	a0,d0
	moveq	#1,d7
.char:
	subq.w	#1,d7
	cmpi.b	#10,(a0)+	; \n
	bne.s	.char
	addi.w	#22,d7
	lsr.w	#1,d7
	movea.l	d0,a0
	adda.l	#W*13,a1	; next line
	bra.w	.loop
.notend:
	addq.w	#2,(a4)
	move.b	1(a0),d0
	ext.w	d0
	lea	cptchar(pc),a1
	move.w	d0,(a1)
	tst.b	2(a0)
	bne.s	.skip2
	move.w	#0,(a4)
.skip2:
	lea	flagVBL(pc),a0
	move.w	#-1,(a0)
.waitvbl:
	move.w	(a0),d0
	bmi.s	.waitvbl
	move.w	#-1,(a0)

	bsr	waitblitter
	lea	ptScreen1(pc),a1
	movea.l	(a1)+,a2
	adda.l	#20,a2
	move.l	a2,bltApth(a6)
	movea.l	(a1)+,a2
	adda.l	#20,a2
	move.l	a2,bltDpth(a6)
	move.w	#W-24,bltAmod(a6)
	move.w	#W-24,bltDmod(a6)
	move.l	#$9F00000,bltcon0(a6)
	move.w	#H*2*64+24/2,bltsize(a6)
	rts
bltcontxt:
	dc.l	$FC20000
	dc.l	$8FC28000
* --------------------------------------------------------
ptTabSin	dc.l	BufTabSin
ptScreen1	dc.l	Screen1		; tweety 1
ptscreen1_2	dc.l	Screen2		; tweety 2
ptScreen2	dc.l	Screen1		; 
ptScreen2_2	dc.l	Screen2
ptPlan5		dc.l	plan5
ptsBounce	dc.l	sBounce
ptBufFont	dc.l	bufFont
ptBufFont2	dc.l	BufFont2
ptPosScreen	dc.l	PosScreen
* ---
flagVBL		dc.w	0
cptwave		dc.w	0
flagtweety	dc.w	0
cptchar		dc.w	0
flag2fad	dc.w	0
* ---
cptBounce	dc.w	0
ptBounce	dc.l	0,0
bltconBounce	dc.l	0,0	; to the right
* -- rabbit
Rabbit1:	incbin	"rabbit1.rw"
Rabbit2:	incbin	"rabbit2.rw"
Rabbit3:	incbin	"rabbit3.rw"
* --
TabSin	incbin	"tabsin"
MoveWave:
	dc.b $20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20,$1f,$1f,$1f,$1f
	dc.b $1f,$1f,$1f,$1e,$1e,$1e,$1e,$1e,$1d,$1d,$1d,$1d,$1d,$1c,$1c
	dc.b $1c,$1c,$1b,$1b,$1b,$1a,$1a,$1a,$19,$19,$19,$19,$18,$18,$17
	dc.b $17,$17,$16,$16,$16,$15,$15,$15,$14,$14,$13,$13,$13,$12,$12
	dc.b $11,$11,$11,$10,$10,$10,$0f,$0f,$0e,$0e,$0e,$0d,$0d,$0c,$0c
	dc.b $0c,$0b,$0b,$0a,$0a,$0a,$09,$09,$09,$08,$08,$08,$07,$07,$07
	dc.b $06,$06,$06,$05,$05,$05,$05,$04,$04,$04,$04,$03,$03,$03,$03
	dc.b $02,$02,$02,$02,$02,$01,$01,$01,$01,$01,$01,$01,$01,$00,$00
	dc.b $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
	dc.b $00,$00,$00,$01,$01,$01,$01,$01,$01,$01,$01,$02,$02,$02,$02
	dc.b $02,$03,$03,$03,$03,$04,$04,$04,$04,$05,$05,$05,$05,$06,$06
	dc.b $06,$07,$07,$07,$08,$08,$08,$09,$09,$09,$0a,$0a,$0a,$0b,$0b
	dc.b $0c,$0c,$0c,$0d,$0d,$0e,$0e,$0e,$0f,$0f,$10,$10,$10,$11,$11
	dc.b $11,$12,$12,$13,$13,$13,$14,$14,$15,$15,$15,$16,$16,$16,$17
	dc.b $17,$17,$18,$18,$19,$19,$19,$19,$1a,$1a,$1a,$1b,$1b,$1b,$1c
	dc.b $1c,$1c,$1c,$1d,$1d,$1d,$1d,$1d,$1e,$1e,$1e,$1e,$1e,$1f,$1f
	dc.b $1f,$1f,$1f,$1f,$1f,$20,$20,$20,$20,$20,$20,$20,$20,$20,$20
	dc.b $20
* ---
Palette:
	dc.w	$445,$fff,0,$334,$f70,$a54,$8c,$48
	dc.w	$7b,$59,$9e,$3f1,$fff,$fe0,$d21,$ccc
	dc.w	$447,$fff,0,$336,$f70,$a54,$8c,$48
	dc.w	$7b,$59,$9e,$3f1,$fff,$fe0,$d21,$ccc
finalcol
	ds.w	32*3
black	ds.w	32*3
* ---
pText	dc.w	0
Text:	dc.b	10
	dc.b	'^ C R Y S T A L ^',10
	dc.b	'cracked',10
	dc.b	10
	dc.b	"'ALLO 'ALLO!",10
	dc.b	'~~~~~~~~~~~~',10
	dc.b	10
	dc.b	'Accept no imitations..',10
	dc.b	"We are the world's #1!",10
	dc.b	0

	dc.b	10
	dc.b	10
	dc.b	'For all in software on',10
	dc.b	'Amiga, PC and consoles',10
	dc.b	'write (please include',10
	dc.b	'a phone-number):',10
	dc.b	10
	dc.b	'P.O. Box 2',10
	dc.b	'8330 Beder',10
	dc.b	'Denmark',10,0
	dc.b	$E ;

	dc.b	10
	dc.b	10
	dc.b	'UK people write:',10
	dc.b	10
	dc.b	'P.O. Box 27DE',10
	dc.b	'Dundee, DD5-3YE',10
	dc.b	'Scotland',10
	dc.b	'UK',10
	dc.b	10,0

	dc.b	10
	dc.b	10
	dc.b	'*Super Nintendo*',10
	dc.b	'*Sega Megadrive*',10
	dc.b	'backup-systems',10
	dc.b	'LOW prices, call!',10
	dc.b	10
	dc.b	'Europe (UK) 0382739192',10
	dc.b	'USA 917 462 5071',10
	dc.b	'Scandi. (DK) 86-937217',10,0
	dc.b	$E ;  

	dc.b	10
	dc.b	10
	dc.b	'.oO Intro Fuglebad Oo.',10
	dc.b	10
	dc.b	"by  $ Ted's Farm $",10
	dc.b	'of Movement',10
	dc.b	10
	dc.b	'Press RETURN to quit!!',10
	dc.b	10,0
	even
picTweety	incbin	"tweety.rw"	; (16*15*4)*2
* ---------------------------------------------------------- COPPERLIST
	section	copper,data_c	
Newcopper:   
	dc.w	$106,$c00,$1fc,0,$10c,$11
	DC.W 	$008E,$5821,$0090,$3ff1
	DC.W 	$0092,$0030,$0094,$00d8		; 46
	DC.W 	$100,$4200,$102,0,$104,0
	dc.w	$106,$c00,$1e4,$2100,$1fc,0	; aga comp
; Sprites	
	DC.W	$120,0,$122,0
	dc.w	$124,0,$126,0
	dc.w	$128,0,$12a,0
	dc.w	$12c,0,$12e,0
	dc.w	$130,0,$132,0
	dc.w	$134,0,$136,0
	dc.w	$138,0,$13a,0
	dc.w	$13c,0,$13e,0
; Modulos 
	dc.w 	$10a,0,$108,0

CLcol1	dc.w	$180,0,$182,0,$184,0,$186,0,$188,0,$18a,0,$18c,0,$18e,0
	dc.w	$190,0,$192,0,$194,0,$196,0,$198,0,$19a,0,$19c,0,$19e,0
	dc.w	$1a0,0,$1a2,0,$1a4,0,$1a6,0,$1a8,0,$1aa,0,$1ac,0,$1ae,0
	dc.w	$1b0,0,$1b2,0,$1b4,0,$1b6,0,$1b8,0,$1ba,0,$1bc,0,$1be,0

CLplan	dc.w	$e0,0,$e2,0
	dc.w	$e4,0,$e6,0
	dc.w	$e8,0,$ea,0
	dc.w	$ec,0,$ee,0
CLplan5	dc.w	$f0,0,$f2,0

	dc.w	$9811,$fffe,$100,$5200
	dc.w	$d8f1,$fffe,$108,-44,$10a,-44

endcop	DC.L 	$FFFFFFFE
* --- bouncing rabbit
CopperList:
	dc.w	$8e,$1921,$90,$2ff1
	dc.w	$92,$0030,$94,$00d8
	dc.w	$106,$c00,$1e4,$2100,$1fc,0	; aga comp
	dc.w	$108,2,$10a,2
	dc.w	$102,0,$104,0
	dc.w	$180,$0000,$182,$0DDD,$184,$0A21,$186,$0555
	dc.w	$188,$0AAA,$18A,$0666,$18C,$0CCC,$18E,$0FFF
	dc.w	$190,$007B,$192,$0059,$194,$0888,$196,$0AAA
	dc.w	$198,$0999,$19A,$0556,$19C,$0445,$19E,$0334
	dc.w	$4011,$fffe
CLplan1	dc.w	$e0,0,$e2,0
	dc.w	$e4,0,$e6,0
	dc.w	$e8,0,$ea,0
	dc.w	$ec,0,$ee,0
linestr	dc.w	0,$fffe,$100,$4200
linestp	dc.w	0,$fffe,$100,0
	dc.l	-2
* -----------------------------------------------------
module:	
music_data:
	ifd	DM
	incbin	"dm2.the_last_v8"
	endc
	
Font	incbin	"font.rw"

	section	scr,bss_c
bufTabSin ds.l	390
sBounce	ds.b	(WB*HB*4)*2
* --- tweety + txt
screen1	ds.b	W*H*4
screen2	ds.b	W*H*4
* wave
plan5	ds.b	W*H2
bufFont	ds.b	9600
BufFont2 ds.w	2304*4
PosScreen ds.w	768
	END
